#include "direct3d.h"

// RXgN^
Direct3D::Direct3D(){
	pD3D9 = NULL;			// Direct3DfoCXpIuWFNg
	pDevice3D = NULL;		// Direct3D̃foCX
}
// fXgN^
Direct3D::~Direct3D(){
	// DirectX̕ϐ͕K㏈邱
	if(pDevice3D != NULL)
		pDevice3D->Release();
	if(pD3D9 != NULL)
		pD3D9->Release();
}

// foCX쐬
bool Direct3D::Create(HWND hWnd,int Width,int Height){
	
	// Direct3D9IuWFNg̍쐬	
	pD3D9 = Direct3DCreate9(D3D_SDK_VERSION);	
	// fBXvC擾
	D3DDISPLAYMODE Display;
	pD3D9->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &Display);

	D3DPRESENT_PARAMETERS	D3DParam = {			// Xbv`FCݒ
		Width,Height,Display.Format,1,D3DMULTISAMPLE_NONE,0,
		D3DSWAPEFFECT_DISCARD,hWnd,TRUE,TRUE,D3DFMT_D24S8,0,0,D3DPRESENT_INTERVAL_DEFAULT
	};			
	
	// HAL[h3DfoCX쐬
	if (FAILED(pD3D9->CreateDevice(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL, D3DParam.hDeviceWindow,
		D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &D3DParam, &pDevice3D)))
	if (FAILED(pD3D9->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, D3DParam.hDeviceWindow, 
		D3DCREATE_MIXED_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &D3DParam, &pDevice3D)))
	// REF[h3DfoCX쐬
	if (FAILED(pD3D9->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, D3DParam.hDeviceWindow, 
		D3DCREATE_HARDWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &D3DParam, &pDevice3D)))
	if (FAILED(pD3D9->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, D3DParam.hDeviceWindow, 
		D3DCREATE_SOFTWARE_VERTEXPROCESSING | D3DCREATE_MULTITHREADED, &D3DParam, &pDevice3D)))
	{
		// 3DfoCX쐬s(̃OtBbN{[hłDirectXgȂ)
		pD3D9->Release();
		return false;
	}

	return true;
}

// _[Xe[g̕ύX
void SetRenderState(IDirect3DDevice9* pD3DDevice,RENDERSTATE RenderState)
{

	switch(RenderState)
	{
	case RENDER_DEFAULT:
		{
			// sIuWFNg
			pD3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, FALSE);		//At@eXg̖
		}
		break;
	case RENDER_ALPHATEST:
		{
			// eXgɂ铧̈̐؂蔲
			pD3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);			//At@eXg̗L
			pD3DDevice->SetRenderState(D3DRS_ALPHAREF, 0x01);					//At@Qƒl
			pD3DDevice->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL);	//At@eXgi
			
		}
		break;
	}
}